#include <iostream>
#include <math.h>
#include "optimizeFundamental.h"
#include "efnsMethod.h"

#define sq(x) ((x) * (x))


/* --------------------------------------------------------------
   ------------------ ꡼Х ----------------------
   ս 4

   ر ʳظ
    ͺ
*/


/**
 * @file бȴùιμ
 * @brief бȴùιԤ
 * @param x1 x2 бǡ
 * @param N бǡο
 * @param f ξΥ
 * @param optimizeThd бμ«Ƚ
 * @param efnsThd бμ«Ƚ
 */
void optimizeFundamental(CvMat **x1,
                         CvMat **x2,
                         CvMat **F,
                         const int N,
                         const double f,
                         const double optimizeThd,
                         const double efnsThd,
                         const int updateFlag) {

  /* {{{ Ƹʤɤν */
  double E0 = 1e+10;
  double E = 0.0;
  double err = 0.0;  //!< «Ƚ
  CvMat *xh1 = cvCreateMat(N, 2, CV_64FC1);
  CvMat *xh2 = cvCreateMat(N, 2, CV_64FC1);
  CvMat *xt1 = cvCreateMat(N, 2, CV_64FC1);
  CvMat *xt2 = cvCreateMat(N, 2, CV_64FC1);
  for(int i = 0; i < N; i++) {
    cvmSet(xh1, i, 0, cvmGet(*x1, i, 0));
    cvmSet(xh1, i, 1, cvmGet(*x1, i, 1));
    cvmSet(xh2, i, 0, cvmGet(*x2, i, 0));
    cvmSet(xh2, i, 1, cvmGet(*x2, i, 1));
  }
  cvSetZero(xt1);
  cvSetZero(xt2);
  /* }}} */

	/* {{{ ȿǻѤʤɤޤȤ */
  CvMat **xi = new CvMat* [N];
  CvMat **V = new CvMat* [N];

   // --------------------------------------------------------------
   // ----------------- ꡼Х(1) --------------------
   // ޤȤ
  for (int i = 0; i < N; i++)
  {
	  xi[i] = cvCreateMat(9, 1, CV_64FC1);
	  V[i] = cvCreateMat(9, 9, CV_64FC1);
  }
  // --------------------------------------------------------------

  CvMat *u = cvCreateMat(9, 1, CV_64FC1);
  CvMat *Vu = cvCreateMat(9, 1, CV_64FC1);
  double uxi, uVu;
  CvMat *scalarMat = cvCreateMat(2, 3, CV_64FC1);
  CvMat *uTmp1 = cvCreateMat(2, 3, CV_64FC1);
  CvMat *uTmp2 = cvCreateMat(2, 3, CV_64FC1);
  CvMat *scalarU = cvCreateMat(2, 3, CV_64FC1);
  CvMat *xtTmp1 = cvCreateMat(2, 1, CV_64FC1);
  CvMat *xtTmp2 = cvCreateMat(2, 1, CV_64FC1);
  CvMat *xhTmp1 = cvCreateMat(3, 1, CV_64FC1);
  CvMat *xhTmp2 = cvCreateMat(3, 1, CV_64FC1);
  CvMat *xTmp = cvCreateMat(2, 1, CV_64FC1);
  CvMat *xhTmp = cvCreateMat(2, 1, CV_64FC1);
  CvMat *xtTmp = cvCreateMat(2, 1, CV_64FC1);
  /* }}} */

  do {

    /* {{{ 9 ٥ȥ xi η׻ */
    for(int i = 0; i < N; i++) {

	  // --------------------------------------------------------------
      // ----------------- ꡼Х(2) --------------------
      // xi[i] = cvCreateMat(9, 1, CV_64FC1);
      // --------------------------------------------------------------

	  cvmSet(xi[i], 0, 0, cvmGet(xh1, i, 0) * cvmGet(xh2, i, 0) + cvmGet(xh2, i, 0) * cvmGet(xt1, i, 0) + cvmGet(xh1, i, 0) * cvmGet(xt2, i, 0));
      cvmSet(xi[i], 1, 0, cvmGet(xh1, i, 0) * cvmGet(xh2, i, 1) + cvmGet(xh2, i, 1) * cvmGet(xt1, i, 0) + cvmGet(xh1, i, 0) * cvmGet(xt2, i, 1));
      cvmSet(xi[i], 2, 0, f * (cvmGet(xh1, i, 0) + cvmGet(xt1, i, 0)));
      cvmSet(xi[i], 3, 0, cvmGet(xh1, i, 1) * cvmGet(xh2, i, 0) + cvmGet(xh2, i, 0) * cvmGet(xt1, i, 1) + cvmGet(xh1, i, 1) * cvmGet(xt2, i, 0));
      cvmSet(xi[i], 4, 0, cvmGet(xh1, i, 1) * cvmGet(xh2, i, 1) + cvmGet(xh2, i, 1) * cvmGet(xt1, i, 1) + cvmGet(xh1, i, 1) * cvmGet(xt2, i, 1));
      cvmSet(xi[i], 5, 0, f * (cvmGet(xh1, i, 1) + cvmGet(xt1, i, 1)));
      cvmSet(xi[i], 6, 0, f * (cvmGet(xh2, i, 0) + cvmGet(xt2, i, 0)));
      cvmSet(xi[i], 7, 0, f * (cvmGet(xh2, i, 1) + cvmGet(xt2, i, 1)));
      cvmSet(xi[i], 8, 0, sq(f));
    }
    /* }}} */
  
    /* {{{ 9x9  V η׻ */
    for(int i = 0; i < N; i++) {

	  // --------------------------------------------------------------
      // ----------------- ꡼Х(3) --------------------
      // V[i] = cvCreateMat(9, 9, CV_64FC1);
	  // --------------------------------------------------------------

      cvmSet(V[i], 0, 0, sq(cvmGet(xh1, i, 0)) + sq(cvmGet(xh2, i, 0)));
      cvmSet(V[i], 0, 1, cvmGet(xh2, i, 0) * cvmGet(xh2, i, 1));
      cvmSet(V[i], 0, 2, f * cvmGet(xh2, i, 0));
      cvmSet(V[i], 0, 3, cvmGet(xh1, i, 0) * cvmGet(xh1, i, 1));
      cvmSet(V[i], 0, 4, 0.0);
      cvmSet(V[i], 0, 5, 0.0);
      cvmSet(V[i], 0, 6, f * cvmGet(xh1, i, 0));
      cvmSet(V[i], 0, 7, 0.0);
      cvmSet(V[i], 0, 8, 0.0);
  
      cvmSet(V[i], 1, 0, cvmGet(xh2, i, 0) * cvmGet(xh2, i, 1));
      cvmSet(V[i], 1, 1, sq(cvmGet(xh1, i, 0)) + sq(cvmGet(xh2, i, 1)));
      cvmSet(V[i], 1, 2, f * cvmGet(xh2, i, 1));
      cvmSet(V[i], 1, 3, 0.0);
      cvmSet(V[i], 1, 4, cvmGet(xh1, i, 0) * cvmGet(xh1, i, 1));
      cvmSet(V[i], 1, 5, 0.0);
      cvmSet(V[i], 1, 6, 0.0);
      cvmSet(V[i], 1, 7, f * cvmGet(xh1, i, 0));
      cvmSet(V[i], 1, 8, 0.0);
  
      cvmSet(V[i], 2, 0, f * cvmGet(xh2, i, 0));
      cvmSet(V[i], 2, 1, f * cvmGet(xh2, i, 1));
      cvmSet(V[i], 2, 2, sq(f));
      cvmSet(V[i], 2, 3, 0.0);
      cvmSet(V[i], 2, 4, 0.0);
      cvmSet(V[i], 2, 5, 0.0);
      cvmSet(V[i], 2, 6, 0.0);
      cvmSet(V[i], 2, 7, 0.0);
      cvmSet(V[i], 2, 8, 0.0);
  
      cvmSet(V[i], 3, 0, cvmGet(xh1, i, 0) * cvmGet(xh1, i, 1));
      cvmSet(V[i], 3, 1, 0.0);
      cvmSet(V[i], 3, 2, 0.0);
      cvmSet(V[i], 3, 3, sq(cvmGet(xh1, i, 1)) + sq(cvmGet(xh2, i, 0)));
      cvmSet(V[i], 3, 4, cvmGet(xh2, i, 0) * cvmGet(xh2, i, 1));
      cvmSet(V[i], 3, 5, f * cvmGet(xh2, i, 0));
      cvmSet(V[i], 3, 6, f * cvmGet(xh1, i, 1));
      cvmSet(V[i], 3, 7, 0.0);
      cvmSet(V[i], 3, 8, 0.0);
  
      cvmSet(V[i], 4, 0, 0.0);
      cvmSet(V[i], 4, 1, cvmGet(xh1, i, 0) * cvmGet(xh1, i, 1));
      cvmSet(V[i], 4, 2, 0.0);
      cvmSet(V[i], 4, 3, cvmGet(xh2, i, 0) * cvmGet(xh2, i, 1));
      cvmSet(V[i], 4, 4, sq(cvmGet(xh1, i, 1)) + sq(cvmGet(xh2, i, 1)));
      cvmSet(V[i], 4, 5, f * cvmGet(xh2, i, 1));
      cvmSet(V[i], 4, 6, 0.0);
      cvmSet(V[i], 4, 7, f * cvmGet(xh1, i, 1));
      cvmSet(V[i], 4, 8, 0.0);
  
      cvmSet(V[i], 5, 0, 0.0);
      cvmSet(V[i], 5, 1, 0.0);
      cvmSet(V[i], 5, 2, 0.0);
      cvmSet(V[i], 5, 3, f * cvmGet(xh2, i, 0));
      cvmSet(V[i], 5, 4, f * cvmGet(xh2, i, 1));
      cvmSet(V[i], 5, 5, sq(f));
      cvmSet(V[i], 5, 6, 0.0);
      cvmSet(V[i], 5, 7, 0.0);
      cvmSet(V[i], 5, 8, 0.0);
  
      cvmSet(V[i], 6, 0, f * cvmGet(xh1, i, 0));
      cvmSet(V[i], 6, 1, 0.0);
      cvmSet(V[i], 6, 2, 0.0);
      cvmSet(V[i], 6, 3, f * cvmGet(xh1, i, 1));
      cvmSet(V[i], 6, 4, 0.0);
      cvmSet(V[i], 6, 5, 0.0);
      cvmSet(V[i], 6, 6, sq(f));
      cvmSet(V[i], 6, 7, 0.0);
      cvmSet(V[i], 6, 8, 0.0);
  
      cvmSet(V[i], 7, 0, 0.0);
      cvmSet(V[i], 7, 1, f * cvmGet(xh1, i, 0));
      cvmSet(V[i], 7, 2, 0.0);
      cvmSet(V[i], 7, 3, 0.0);
      cvmSet(V[i], 7, 4, f * cvmGet(xh1, i, 1));
      cvmSet(V[i], 7, 5, 0.0);
      cvmSet(V[i], 7, 6, 0.0);
      cvmSet(V[i], 7, 7, sq(f));
      cvmSet(V[i], 7, 8, 0.0);
  
      cvmSet(V[i], 8, 0, 0.0);
      cvmSet(V[i], 8, 1, 0.0);
      cvmSet(V[i], 8, 2, 0.0);
      cvmSet(V[i], 8, 3, 0.0);
      cvmSet(V[i], 8, 4, 0.0);
      cvmSet(V[i], 8, 5, 0.0);
      cvmSet(V[i], 8, 6, 0.0);
      cvmSet(V[i], 8, 7, 0.0);
      cvmSet(V[i], 8, 8, 0.0);
    }
    /* }}} */
  
    /* {{{ ĥFNS (EFNS) Ǵù򹹿 */
    for(int i = 0; i < 9; i++) {
      cvmSet(u, i, 0, cvmGet(*F, i/3, i%3));
    }
    if(updateFlag == FUNDAMENTAL_UPDATE) {
      efnsMethod(xi, V, &u, N, efnsThd);
      for(int i = 0; i < 9; i++) {
        cvmSet(*F, i/3, i%3, cvmGet(u, i, 0));
      }
    }
    /* }}} */
  
    /* {{{ xh1 xh2 ι */
    cvmSet(xhTmp1, 2, 0, f);
    cvmSet(xhTmp2, 2, 0, f);
    cvmSet(uTmp1, 0, 0, cvmGet(u, 0, 0));
    cvmSet(uTmp1, 0, 1, cvmGet(u, 1, 0));
    cvmSet(uTmp1, 0, 2, cvmGet(u, 2, 0));
    cvmSet(uTmp1, 1, 0, cvmGet(u, 3, 0));
    cvmSet(uTmp1, 1, 1, cvmGet(u, 4, 0));
    cvmSet(uTmp1, 1, 2, cvmGet(u, 5, 0));
    cvmSet(uTmp2, 0, 0, cvmGet(u, 0, 0));
    cvmSet(uTmp2, 0, 1, cvmGet(u, 3, 0));
    cvmSet(uTmp2, 0, 2, cvmGet(u, 6, 0));
    cvmSet(uTmp2, 1, 0, cvmGet(u, 1, 0));
    cvmSet(uTmp2, 1, 1, cvmGet(u, 4, 0));
    cvmSet(uTmp2, 1, 2, cvmGet(u, 7, 0));
    for(int i = 0; i < N; i++) {
      uxi = cvDotProduct(u, xi[i]);
      cvmMul(V[i], u, Vu);
      uVu = cvDotProduct(u, Vu);
      for(int j = 0; j < 2; j++) {
        cvmSet(xhTmp1, j, 0, cvmGet(xh2, i, j));
        cvmSet(xhTmp2, j, 0, cvmGet(xh1, i, j));
      }
      for(int j = 0; j < 2; j++) {
        for(int k = 0; k < 3; k++) {
          cvmSet(scalarMat, j, k, uxi/uVu);
        }
      }
      cvMul(scalarMat, uTmp1, scalarU);
      cvmMul(scalarU, xhTmp1, xtTmp1);
      cvMul(scalarMat, uTmp2, scalarU);
      cvmMul(scalarU, xhTmp2, xtTmp2);
      cvmSet(xt1, i, 0, cvmGet(xtTmp1, 0, 0));
      cvmSet(xt1, i, 1, cvmGet(xtTmp1, 1, 0));
      cvmSet(xt2, i, 0, cvmGet(xtTmp2, 0, 0));
      cvmSet(xt2, i, 1, cvmGet(xtTmp2, 1, 0));
    }
    /* }}} */
  
    /* {{{ xh1 xh2 ι */
    for(int i = 0; i < N; i++) {
      for(int j = 0; j < 2; j++) {
        cvmSet(xTmp, j, 0, cvmGet(*x1, i, j)); 
        cvmSet(xtTmp, j, 0, cvmGet(xt1, i, j)); 
      }
  		cvmSub(xTmp, xtTmp, xhTmp);
      for(int j = 0; j < 2; j++) {
        cvmSet(xh1, i, j, cvmGet(xhTmp, j, 0));
      }
      for(int j = 0; j < 2; j++) {
        cvmSet(xTmp, j, 0, cvmGet(*x2, i, j)); 
        cvmSet(xtTmp, j, 0, cvmGet(xt2, i, j)); 
      }
  		cvmSub(xTmp, xtTmp, xhTmp);
      for(int j = 0; j < 2; j++) {
        cvmSet(xh2, i, j, cvmGet(xhTmp, j, 0));
      }
    }
    /* }}} */
  
    /* {{{ Ƹη׻ */
    E = 0.0;
    for(int i = 0; i < N; i++) {
      E += sq(cvmGet(xt1, i, 0)) + sq(cvmGet(xt1, i, 1)) + sq(cvmGet(xt2, i, 0)) + sq(cvmGet(xt2, i, 1));
    }
    E = sqrt(E / (double)(N - 7));
    std::cout << "# Ƹ : " << E << std::endl;
    /* }}} */

  /* {{{ «Ƚ */
  err = fabs(E - E0);
  E0 = E;
  /* }}} */
  } while(err >= optimizeThd);

	/* {{{ бǡι */
  if(updateFlag == CORRESPOND_UPDATE) {
    for(int i = 0; i < N; i++) {
      for(int j = 0; j < 2; j++) {
        cvmSet(*x1, i, j, cvmGet(xh1, i, j));
        cvmSet(*x2, i, j, cvmGet(xh2, i, j));
      }
    }
  }
  /* }}} */

  /* {{{ Ѥ CvMat γ */

  // --------------------------------------------------------------
  // ----------------- ꡼Х(4) --------------------
  // β
  for (int i = 0; i < N; i++)
  {
	  cvReleaseMat(&xi[i]);
	  cvReleaseMat(&V[i]);
  }
  // ѤCvMatβ(­ʬ)
  cvReleaseMat(&xh1);
  cvReleaseMat(&xh2);
  cvReleaseMat(&xt1);
  cvReleaseMat(&xt2);
  // --------------------------------------------------------------

  delete [] xi;
  delete [] V;
  cvReleaseMat(&u);
  cvReleaseMat(&Vu);
  cvReleaseMat(&scalarMat);
  cvReleaseMat(&uTmp1);
  cvReleaseMat(&uTmp2);
  cvReleaseMat(&scalarU);
  cvReleaseMat(&xtTmp1);
  cvReleaseMat(&xtTmp2);
  cvReleaseMat(&xTmp);
  cvReleaseMat(&xhTmp);
  cvReleaseMat(&xtTmp);
  /* }}} */
}
